/**********************************************************
 * EMSI management.
 **********************************************************/
/*
 * $Id: emsi.c,v 1.9 2005/02/12 18:48:18 mitry Exp $
 *
 * $Log: emsi.c,v $
 * Revision 1.9  2005/02/12 18:48:18  mitry
 * Adde some code in emsi_init() to speed up ifcico connect with fckng T-Mail.
 *
 *
 */

#include "headers.h"
#include "qipc.h"
#include "crc.h"
#include "tty.h"

#define EMSI_BUF	8192
#define TMP_LEN		1024
#define EMSI_CAT(p)	xstrcat( emsi_dat, (p), EMSI_BUF - strlen( emsi_dat ) - 1 )

char emsi_dat[EMSI_BUF + 1];

#define EMSI_BEG "**EMSI_"
#define PUTSTRCR( str ) PUTSTR( str ); PUTCHAR( '\r' )

static char *emsireq = "**EMSI_REQA77E";
static char *emsiack = "**EMSI_ACKA490";
static char *emsiinq = "**EMSI_INQC816";
static char *emsinak = "**EMSI_NAKEEC3";
static char *emsihbt = "**EMSI_HBTEAEE";
static char *emsidat = "**EMSI_DAT";

static int chat_need = -1, chatmy = -1;


void emsi_makedat(ftnaddr_t *remaddr, unsigned long mail, unsigned long files,
    int lopt, char *protos, falist_t *adrs, int showpwd)
{
    char tmp[TMP_LEN], *p, *xstr;
    int c;
    falist_t *cs;
    ftnaddr_t *ba;
    time_t tm = time( NULL );

    *emsi_dat = 0;
    EMSI_CAT( "**EMSI_DAT0000{EMSI}{" );

    /* Put best AKA first */
    ba = akamatch( remaddr, adrs ? adrs : cfgal( CFG_ADDRESS ));
    EMSI_CAT( ba->d ? ftnaddrtoda( ba ) : ftnaddrtoa( ba ));
    
    /* Fill rest AKAs */
    for( cs = cfgal( CFG_ADDRESS ); cs; cs = cs->next )
        if ( &cs->addr != ba ) {
            EMSI_CAT( " " );
            EMSI_CAT( cs->addr.d ? ftnaddrtoda( &cs->addr ) : ftnaddrtoa( &cs->addr ));
        }

    EMSI_CAT( "}{" );

    if ( showpwd && ( p = findpwd( remaddr )))
        EMSI_CAT( p );

    EMSI_CAT( "}{8N1" );
    
    if ( strchr( protos, 'H' ) || strchr( protos, 'h' )

#ifdef HYDRA8K16K

        || strchr( protos, '4' ) || strchr( protos, '8' ) || strchr( protos, '6' )

#endif/*HYDRA8K16K*/

        )
        EMSI_CAT( ",RH1" );

    if ( lopt & O_PUA )
        EMSI_CAT( ",PUA" );

    if ( lopt & O_PUP )
        EMSI_CAT( ",PUP" );

    /* Should be presented only by answering system. Calling system should
       set NRQ */
    if ( lopt & O_HRQ )
        EMSI_CAT( ",HRQ" );

    if ( lopt & O_HXT )
        EMSI_CAT( ",HXT" );

    if ( lopt & O_HAT )
        EMSI_CAT( ",HAT" );

    EMSI_CAT( "}{" );

    p = protos;
    c = chatmy = 0;

    if ( !( lopt & P_NCP )) {
        while( *p ) {
            switch(toupper(*p++)) {
                case '1':
                    EMSI_CAT( "ZMO," );
                    c = 1;
                    break;

                case 'Z':
                    EMSI_CAT( "ZAP," );
                    c = 1;
                    break;

                case 'D':
                    EMSI_CAT( "DZA," );
                    c = 1;
                    break;

                case 'H':
                    EMSI_CAT( "HYD," );
                    c = 1;
                    break;

#ifdef HYDRA8K16K
                case '4':
                    EMSI_CAT( "HY4," );
                    c = 1;
                    break;

                case '8':
                    EMSI_CAT( "HY8," );
                    c = 1;
                    break;

                case '6':
                    EMSI_CAT( "H16," );
                    c = 1;
                    break;

#endif/*HYDRA8K16K*/

                case 'J':
                    EMSI_CAT( "JAN," );
                    c = 1;
                    break;

                case 'C':
                    EMSI_CAT( "CHT," );
                    chatmy = 1;
                    break;
            }
        }

        if ( lopt & O_NRQ )
            EMSI_CAT( "NRQ," );
    }

    if ( !c )
        EMSI_CAT( "NCP," );

    EMSI_CAT( "ARC,XMA}{FE" );

    for( c = 0; c < 3; c++ ) {
        xstr = strip8( xstrdup( qver( c )));
        EMSI_CAT( "}{" );
        EMSI_CAT( xstr );
        xfree( xstr );
    }
    EMSI_CAT( "}" );

    snprintf( tmp, TMP_LEN,
        "{IDENT}{[%s][%s][%s][%s][%d][%s]}{TRAF}{%lX %lX}{MOH#}{[%lX]}{OHFR}{%s %s}{TRX#}{[%lX]}{TZUTC}{[%+03ld00]}",
        strip8( cfgs( CFG_STATION )), strip8( cfgs( CFG_PLACE )),
        strip8( cfgs( CFG_SYSOP )), strip8( cfgs( CFG_PHONE )),
        cfgi( CFG_SPEED ), strip8( cfgs( CFG_FLAGS )),
        mail, files, mail + files,
        strip8( strdup( cfgs( CFG_WORKTIME ) ? ccs : MSG_NEVER )),
        strip8( strdup(( lopt & O_NOFREQS ) ? MSG_NEVER :
            cfgs( CFG_EMSIFREQTIME ) ? ccs :
            cfgs( CFG_FREQTIME ) ? ccs : MSG_NEVER )),
        time( NULL ) + gmtoff( tm, 0 ), gmtoff( tm, 0 ) / 3600 );

    EMSI_CAT( tmp );

    /* Calculate emsi length */
    snprintf( tmp, TMP_LEN, "%04X", strlen( emsi_dat ) - 14 );
    memcpy( emsi_dat + 10, tmp, 4 );

    /* EMSI crc16 */
    snprintf( tmp, TMP_LEN, "%04X", crc16usds( (UINT8 *) emsi_dat + 2 ));
    EMSI_CAT( tmp );

    if ( cfgs( CFG_LOGLEVELS ) && ( p = strchr( ccs, 'E' )) && cfgs( CFG_EMSILOG )) {
        FILE *elog;
        elog = fopen( ccs, "at" );
        if ( elog ) {
            fprintf( elog, "out: %s\n", emsi_dat );
            fclose( elog );
        }
    }
}


static char *emsi_tok(char **b, char *kc)
{
    char *p = *b, *t;

    if ( *p != kc[0] )
        return NULL;

    t = ++p;

    while( *t && *t != kc[1] ) {
        if ( t[1] && t[1] == kc[1] && t[2] && t[2] == kc[1] )
            t += 2;
        t++;
    }
    
    if ( !*t )
        return NULL;

    if ( *t == kc[1] ) {
        *t++ = 0;
        *b = t;
        return p;
    }

    return NULL;
}

static void emsi_dcds(char *s)
{
    char *d = s, *x = s, t;

    while(( t = *s )) {
        if ( t == '}' || t == ']' )
            t = *++s;
        if( t != '\\' )
            *d = C0( t );
        else {
            *d = hexdcd( s[1], s[2] );
            s += 2;
        }
        s++;
        d++;
    }

    *d = 0;
    recode_to_local( x );
}

#define EMSI_TOK( from, to ) \
    to = emsi_tok( from, "{}" ); \
    if ( !to )                   \
        return 0;                \
    emsi_dcds( to );

#define EMSI_TOKN( from, to ) \
    to = emsi_tok( from, "{}" ); \
    if ( !to )                   \
        return 0;

/* for IDENT */
#define EMSI_TOKI( from, to ) \
    to = emsi_tok( from, "[]" ); \
    emsi_dcds( to );

int emsi_parsedat(char *str, ninfo_t *dat)
{
    char *p, *t, *s, *lcod, *ccod;
    int l;
    FTNADDR_T(fa);
    FILE *elog;

    if ( cfgs( CFG_LOGLEVELS ) && ( p = strchr( ccs, 'E' )) && cfgs( CFG_EMSILOG )) {
        elog = fopen( ccs, "at" );
        if ( elog ) {
            fprintf( elog, " in: %s\n", str );
            fclose( elog );
        }
    }
    
    if ( !( str = strstr( str, emsidat )))
        return 0;

    sscanf( str + 10, "%04X", (unsigned *) &l );
    if ( l != strlen( str ) - 18 )
        return 0; /* Bad EMSI length */
    DEBUG(('E',5,"EMSI_DAT length (%d) is OK!", l ));

    sscanf( str + strlen( str ) - 4, "%04X", (unsigned*) &l);
    if ( l != crc16usd( (UINT8 *) str + 2, strlen( str ) - 6 ))
        return 0; /* Bad EMSI CRC */
    DEBUG(('E',5,"EMSI_DAT CRC (%04X) is OK!", l ));

    if ( strncmp( str + 14, "{EMSI}", 6))
        return 0; /* No EMSI ident */

    t = str + 20;
    *str = 1;

    EMSI_TOK( &t, p ) /* {AKAs} */

    falist_kill( &dat->addrs );

    while(( s = strsep( &p, " " )))
        if ( parseftnaddr( s, &fa, NULL, 0 ))
            if ( !falist_find( dat->addrs, &fa ))
                falist_add( &dat->addrs, &fa );

    EMSI_TOK( &t, p ) /* Password */
    if ( *p )
        restrcpy( &dat->pwd, p );
    else
        dat->pwd = NULL;

    EMSI_TOK( &t, p ) /* Link codes */
    lcod = p;
    
    EMSI_TOK( &t, p ) /* Compatibility codes */
    ccod = p;
    
    EMSI_TOK( &t, p ) /* Mailer code */
    
    EMSI_TOK( &t, p ) /* Mailer name */
    restrcpy( &dat->mailer, p );

    EMSI_TOK( &t, p ) /* Mailer version */
    if ( *p ) {
        restrcat( &dat->mailer, " " );
        restrcat( &dat->mailer, p );
    }

    EMSI_TOK( &t, p ) /* Mailer serial number */
    if ( *p ) {
        restrcat( &dat->mailer, "/" );
        restrcat( &dat->mailer, p );
    }
    DEBUG(('E',4,"remote mailer '%s'", dat->mailer ));

    DEBUG(('E',1,"emsi codes %s/%s", lcod, ccod));
    dat->options |= emsi_parsecod( lcod, ccod );

    if ( chat_need == 1 && chatmy != 0)
        dat->opt |= MO_CHAT;

    xfree( dat->wtime );

    DEBUG(('E',5,"t: '%s'", t));
    while(( p = emsi_tok( &t, "{}" ))) {
        DEBUG(('E',5,"Parsing p: '%s', t: '%s'", p, t));
        if ( !strcmp( p, "IDENT" )) {
            EMSI_TOKN( &t, p )
            DEBUG(('E',5,"IDENT  p: '%s', t: '%s'", p, t));

            /* System name */
            EMSI_TOKI( &p, s )
            DEBUG(('E',5,"System name  s: '%s', p: '%s'", s, p));
            restrcpy( &dat->name, s );

            /* System location */
            EMSI_TOKI( &p, s )
            DEBUG(('E',5,"System location  s: '%s', p: '%s'", s, p));
            restrcpy( &dat->place, s );

            /* Operator name */
            EMSI_TOKI( &p, s )
            DEBUG(('E',5,"Operator name  s: '%s', p: '%s'", s, p));
            restrcpy( &dat->sysop, s );

            /* Phone */
            EMSI_TOKI( &p, s )
            DEBUG(('E',5,"Phone  s: '%s', p: '%s'", s, p));
            restrcpy(&dat->phone,s);

            /* Baud rate */
            EMSI_TOKI( &p, s )
            DEBUG(('E',5,"Baud rate  s: '%s', p: '%s'", s, p));
            if ( s )
                 sscanf( s, "%d", &dat->speed );

            /* Flags */
            EMSI_TOKI( &p, s )
            DEBUG(('E',5,"Flags  s: '%s', p: '%s'", s, p));
            restrcpy( &dat->flags, s );

        } else if( !strcmp( p, "TRAF" )) {
            EMSI_TOK( &t, p )
            DEBUG(('E',5,"TRAF  p: '%s', t: '%s'", p, t));
            sscanf( p, "%x %x", (unsigned*)&dat->netmail, (unsigned*)&dat->files );

        } else if ( !strcmp( p, "OHFR" )) {
            EMSI_TOK( &t, p )
            DEBUG(('E',5,"OHFR  p: '%s', t: '%s'", p, t));
            restrcpy( &dat->wtime, p );

        } else if( !strcmp( p, "MOH#" )) {
            EMSI_TOKN( &t, p )
            DEBUG(('E',5,"MOH#  p: '%s', t: '%s'", p, t));
            EMSI_TOKI( &p, s )
            DEBUG(('E',5,"MOH#  s: '%s', p: '%s'", s, p));
            if ( sscanf( s, "%x", (unsigned*)&dat->holded ) != 1 )
                return 0;

        } else if ( !strcmp( p, "TRX#" )) {
            EMSI_TOKN( &t, p )
            DEBUG(('E',5,"TRX#  p: '%s', t: '%s'", p, t));
            EMSI_TOKI( &p, s )
            DEBUG(('E',5,"TRX#  s: '%s', p: '%s'", s, p));
            if ( sscanf( s, "%lx", (unsigned long*)&dat->time) !=1 )
                return 0;

        } else p = emsi_tok( &t, "{}" );
    }
    return 1;
}

int emsi_send(int mode, char *dat)
{
    time_t t1,t2;
    int tries=0,got=0,ch;
    char str[MAX_STRING],*p=str;
    
    memset(str,0,MAX_STRING);
    t1=timer_set(cfgi(CFG_HSTIMEOUT));
    while(1) {
        tries++;
        if(tries>10)return TIMEOUT;
        sline("Sending EMSI_DAT");
        DEBUG(('E',1,"Sending EMSI_DAT (%d)",tries));
        PUTSTRCR((unsigned char *)dat);
        t2=timer_set(20);got=0;p=str;
        while(1) {
            ch=GETCHAR(MIN(timer_rest(t1),timer_rest(t2)));
            if(NOTTO(ch))return ch;
            if(timer_expired(t1))return TIMEOUT;
            if(timer_expired(t2))break;
            if(!got&&ch=='*')got=1;
            if(got&&(ch=='\r'||ch=='\n')) {
                *p=0;p=str;got=0;
                        DEBUG(('E',2,"Got str '%s' (%d)",str,strlen(str)));
                if(!strncmp(str,emsiack,14)) {
                    sline("Got EMSI_ACK");
                    DEBUG(('E',1,"Got EMSI_ACK"));
                    return OK;
                }
                if(!strncmp(str,emsireq,14)) {
                    sline("Got strange EMSI_REQ");
                    /* DEBUG(('E',1,"Got strange EMSI_REQ, send EMSI_INQ (safe)"));
                    PUTSTR((unsigned char*)emsiinq);
                    break; */
                    DEBUG(('E',1,"Skipping EMSI_REQ"));
                    continue;
                }
                if(!strncmp(str,emsiack,7))break;
            }
            if(got)*p++=ch;
            if((p-str)>=MAX_STRING) {
                got=0;p=str;
            }
        }
    }
}

/*
  Is use a `goto' a poor programmer's style? But who cares? :)
*/
int emsi_recv(int mode, ninfo_t *rememsi)
{
    int tries, got = 0, ch;
    time_t t1, t2;
    char inbuf[EMSI_BUF], *p = inbuf, *rew;

    /* Step 1
    +-+------------------------------------------------------------------+
    :1: Tries=0, T1=20 seconds, T2=60 seconds                            :
    +-+------------------------------------------------------------------+
    */
    DEBUG(('E',5,"Step 1"));
    tries = 0;
    t1 = timer_set( 20 );
    t2 = timer_set( cfgi( CFG_HSTIMEOUT ));


    do {

step2:
        /* Step 2
        +-+------------------------------------------------------------------+
        :2: Increment Tries                                                  :
        : :                                                                  :
        : : Tries>6?                      Terminate, and report failure.     :
        : +------------------------------------------------------------------+
        : : Are we answering system?      Transmit EMSI_REQ, go to step 3.   :
        : +------------------------------------------------------------------+
        : : Tries>1?                      Transmit EMSI_NAK, go to step 3.   :
        : +------------------------------------------------------------------+
        : : Go to step 4.                                                    :
        +-+------------------------------------------------------------------+
        */
        DEBUG(('E',5,"Step 2"));

        if ( ++tries > 6 ) {
            sline( "EMSI receive failed - too many tries" );
            DEBUG(('E',1,"EMSI receive failed - too many tries"));
            return TIMEOUT;
        }

        if ( mode == SM_INBOUND ) {
            sline( "Sending EMSI_REQ (%d)...", tries );
            DEBUG(('E',1,"Sending EMSI_REQ (%d)...",tries));
            PUTSTRCR( (unsigned char*) emsireq );

        } else if ( tries > 1 ) {
            sline( "Sending EMSI_NAK..." );
            DEBUG(('E',1,"Sending EMSI_NAK (%d)...",tries));
            PUTSTRCR( (unsigned char*) emsinak );

        } else
            goto step4;

step3:
        /* Step 3
        +-+------------------------------------------------------------------+
        :3: T1=20 seconds                                                    :
        +-+------------------------------------------------------------------+
        */
        DEBUG(('E',5,"Step 3"));

        t1 = timer_set( 20 );

step4:
        /* Step 4
        +-+------------------------------------------------------------------+
        :4: Wait for EMSI sequence until EMSI_HBT or EMSI_DAT or any of the  :
        : : timers have expired.                                             :
        : :                                                                  :
        : : If T2 has expired, terminate call and report failure.            :
        : +------------------------------------------------------------------+
        : : If T1 has expired, go to step 2.                                 :
        : +------------------------------------------------------------------+
        : : If EMSI_HBT received, go to step 3.                              :
        : +------------------------------------------------------------------+
        : : If EMSI_DAT received, go to step 5.                              :
        : +------------------------------------------------------------------+
        : : Go to step 4.                                                    :
        +-+------------------------------------------------------------------+
        */
        DEBUG(('E',5,"Step 4"));

        bzero( inbuf, EMSI_BUF );
        p = inbuf;
        got = 0;

        while( CARRIER() ) {
            ch = GETCHAR( MIN( timer_rest( t1 ), timer_rest( t2 )));
            DEBUG(('E',2,"getchar '%c' %d (%d, %d)", C0( ch ), ch, timer_rest( t1 ), timer_rest( t2 )));

            if ( NOTTO( ch ))
                return ch;

            if ( timer_expired( t2 )) {
                sline( "Timeout receiving EMSI_DAT" );
                DEBUG(('E',1,"Timeout receiving EMSI_DAT"));
                return TIMEOUT;
            }

            if ( timer_expired( t1 ))
                break; /* goto step2; */

            if ( !got ) {
                if( ch == '*' )
                    got = 1;
                else
                    continue;
            }

            if ( ch == '\r' || ch == '\n' ) {
                if ( !strncmp( inbuf, emsihbt, 14 )) {
                    sline( "Received EMSI_HBT" );
                    DEBUG(('E',1,"Received EMSI_HBT"));
                    goto step3;
                }

                if ( !strncmp( inbuf, emsidat, 10 )) {

                    /* Step 5
                    +-+------------------------------------------------------------------+
                    :5: Receive EMSI_DAT packet                                          :
                    : +------------------------------------------------------------------+
                    : : Packet received OK?                Transmit EMSI_ACK twice, and  :
                    : :                                    go to step 6.                 :
                    : +------------------------------------------------------------------+
                    : : Go to step 2.                                                    :
                    +-+------------------------------------------------------------------+
                    */
                    DEBUG(('E',5,"Step 5"));

                    sline( "Received EMSI_DAT" );
                    DEBUG(('E',1,"Received EMSI_DAT"));
                    ch = emsi_parsedat( inbuf, rememsi );
                    DEBUG(('E',1,"Parser result: %d", ch));
                    if ( ch ) {
                        sline( "EMSI_DAT OK. Sending EMSI_ACK...");
                        DEBUG(('E',1,"EMSI_DAT OK. Sending EMSI_ACK"));
                        PUTSTRCR( (unsigned char*) emsiack );
                        PUTSTRCR( (unsigned char*) emsiack );

                        /* Step 6
                        +-+------------------------------------------------------------------+
                        :6: Received EMSI_DAT packet OK, exit.                               :
                        +-+------------------------------------------------------------------+
                        */
                        DEBUG(('E',5,"Step 6"));

                        return OK;

                    } else {
                        DEBUG(('E',1,"got str '%s' %d", inbuf, strlen(inbuf)));
                        goto step2;
                    }

                }
                goto step4;

            } else {
                if (( p - inbuf + 1 ) >= EMSI_BUF ) {
                    write_log( "Too long EMSI packet" );
                    rew = NULL;
                    rew = strstr( inbuf + 1, EMSI_BEG );
                    if ( rew && rew != inbuf ) {
                        DEBUG(('E',1,"got EMSI_DAT at offset %d", p - rew));
                        memmove( inbuf, rew, p - rew );
                        p -= rew - inbuf;
                    } else {
                        p = inbuf;
                    }
                    bzero( p, EMSI_BUF - (p - inbuf));
                }
                *p++ = ch;
            }
        }
    } while( !timer_expired( t2 ));

    return TIMEOUT;
}

/*        
    while( 1 ) {
        while( CARRIER() ) {
            ch=GETCHAR(MIN(timer_rest(t1),timer_rest(t2)));
            if(ch<0)break;
            if(!got&&ch=='*') got=1;
            if(got&&(ch=='\r'||ch=='\n'||(emsidatgot==emsidatlen))) {
                DEBUG(('E',2,"Got %d bytes of %d of EMSI_DAT",emsidatgot,emsidatlen));
                *p=0;p=str;got=0;
                emsidatgot=-1;emsidatlen=0;
                emsidathdr=NULL;
#ifdef NEED_DEBUG
                if(strstr(str,emsidat))DEBUG(('E',1,"EMSI_DAT at offset %d",strstr(str,emsidat)-str));
#endif
                DEBUG(('E',1,"got str '%s' %d",str,strlen(str)));

                if(!strncmp(str,emsidat,10)) {
                    sline("Received EMSI_DAT");
                    DEBUG(('E',1,"Received EMSI_DAT"));
                    ch=emsi_parsedat(str, rememsi);
                    DEBUG(('E',1,"Parser result: %d", ch));
                    if(ch) {
                        sline("Sending EMSI_ACK...");
                        DEBUG(('E',1,"Sending EMSI_ACK"));
                        PUTSTRCR( (unsigned char*) emsiack );
                        PUTSTRCR( (unsigned char*) emsiack );
                        return OK;
                    } else break;
                }
            }
            if(got) *p++=ch;
            if((p-str)>=EMSI_BUF) {
                write_log("too long EMSI packet");
                got=0;p=str;
            }
            if(emsidatlen) {
                emsidatgot++;
            } else if((emsidathdr=strstr(str, emsidat)) && (p-emsidathdr==14)) {
                *p = 0;
                sscanf(emsidathdr+10,"%04X",(unsigned*)&emsidatlen);
                emsidatgot = 0;
                emsidatlen += 4; /+* CRC on the end of EMSI_DAT is 4 bytes long *+/
                DEBUG(('E',1,"Got start of EMSI_DAT, length is %d",emsidatlen));
            }
            if(timer_expired(t2)) {
                sline("Timeout receiving EMSI_DAT");
                DEBUG(('E',1,"Timeout receiving EMSI_DAT"));
                return TIMEOUT;
            }
            if(timer_expired(t1)) break;
        }
    }
}
*/

int emsi_init(int originator)
{
    int ch = TIMEOUT, got = 0;
    time_t t1, t2;
    char str[EMSI_BUF], *p = str;
    int tries = 0;
    int do_prevent = !cfgi( CFG_STANDARDEMSI );

    if ( originator ) {
        t1 = timer_set( cfgi( CFG_HSTIMEOUT ));

        do { 
            PUTCHAR('\r');
            ch = HASDATA( timer_rest( t1 )); 
        } while ( !ISTO( ch ) && !timer_expired( t1 ));

        if ( NOTTO( ch ))
            return ch;

        if ( timer_expired( t1 ))
            return TIMEOUT;

        t1 = timer_set( cci );
        t2 = timer_set( 5 );

        while( CARRIER() ) {
            ch = GETCHAR( MIN( timer_rest( t1 ), timer_rest( t2 )));
            DEBUG(('E',2,"getchar '%c' %d (%d, %d)", C0( ch ), ch, timer_rest( t1 ), timer_rest( t2 )));

            if ( NOTTO( ch ))
                return ch;
            
            if( !timer_rest( t1 ))
                return TIMEOUT;

            if ( !got && ch == '*' )
                got = 1;

            if ( got && ( ch == '\r' || ch == '\n' )) {
                *p = 0;
                p = str;
                got=0;
                
                if ( strstr( str, emsireq )) {
                    sline( "Received EMSI_REQ, sending EMSI_INQ..." );
                    DEBUG(('E',1,"Got EMSI_REQ, sending EMSI_INQ.."));
                    PUTSTRCR( (unsigned char*) emsiinq );
                    return OK;
                } else {
                    str[79] = 0;
                    if ( cfgi( CFG_SHOWINTRO ) && *str )
                        write_log( "intro: %s", str );
                }
            }

            if ( got && ch >= 32 && ch <= 255 )
                *p++ = ch;

            if (( p - str ) >= EMSI_BUF ) {
                got = 0;
                p = str;
            }

            if ( !timer_rest( t2 ) && CARRIER()) {
                t2 = timer_set( 5 );

                if ( do_prevent ) {
                    do_prevent = 0;
                    if ( tries++ == 1 ) {
                        sline( "Sending preventive EMSI_INQ..." );
                        DEBUG(('E',1,"Sending preventive EMSI_INQ..."));
                        PUTSTRCR( (unsigned char*) emsiinq );
                        continue;
                    }
                }
                
                if ( tries++ > 10 )
                    return TIMEOUT;

                sline( "Sending EMSI_INQ (Try %d of %d)...", tries, 10 );
                DEBUG(('E',1,"Sending EMSI_INQ (Try %d of %d)...",tries,10));
                PUTSTR( (unsigned char*) emsiinq );
                PUTSTRCR( (unsigned char*) emsiinq );
            }

        }

        if ( !CARRIER())
            return RCDO;

        return OK;
    }

    BUFFLUSH();
    PURGEALL();
    sline( "Sending EMSI_REQ..." );
    DEBUG(('E',1,"Sending EMSI_REQ"));
    PUTCHAR( '\r' );
    PUTSTRCR( (unsigned char*) emsireq );
    sline( "Waiting for EMSI_INQ..." );
    DEBUG(('E',1,"Waiting for EMSI_INQ"));

    t1 = timer_set( cfgi( CFG_HSTIMEOUT ));
    t2 = timer_set( 5 );

    while( !timer_expired( t1 )) {
        ch = GETCHAR( (int) timer_rest( t1 ));

        DEBUG(('E',2,"getchar '%c' %d (%d)", C0( ch ), ch, timer_rest( t1 )));

        if ( NOTTO( ch ))
            return ch;

        if ( !got && ch == '*' )
            got = 1;

        if ( !got && timer_expired( t2 )) {
            sline( "Re-sending EMSI_REQ..." );
            DEBUG(('E',1,"Re-sending EMSI_REQ"));
            PUTCHAR( '\r' );
            PUTSTRCR( (unsigned char*) emsireq );
            sline( "Waiting for EMSI_INQ..." );
            DEBUG(('E',1,"Waiting for EMSI_INQ"));
            t2 = timer_set( 5 );
        }

        if ( got && ( ch == '\r' || ch == '\n' )) {
            *p = 0;
            p = str;
            got=0;
            
            if ( strstr( str, emsiinq )) {
                sline( "Received EMSI_INQ" );
                DEBUG(('E',1,"Got EMSI_INQ"));
                return OK;
            }
        } else {
            if ( got && ch >= 32 && ch <= 255 )
                *p++ = ch;

            if (( p - str ) >= EMSI_BUF ) {
                got = 0;
                p = str;
            }
        }
    }

    /*
    sline( "Sending EMSI_REQ..." );
    DEBUG(('E',1,"Sending EMSI_REQ"));
    PUTSTRCR( (unsigned char*) emsireq );
    sline( "Waiting for EMSI_INQ..." );
    DEBUG(('E',1,"Waiting for EMSI_INQ"));
    ch = tty_expect( emsiinq, 20 );
    */
    return ch;
}


static char *ccodes[2] = {
    "ZMO,ZAP,DZA,"
#ifdef HYDRA8K16K
    "HY4,HY8,H16,"
#endif
    "HYD,JAN,NCP,NRQ,FNC,EII,XMA,ARC,",
    "RH1,PUA,PUP,NPU,HAT,HXT,HRQ,8N1,"
};

static int iccodes[2][14] = {
    { P_ZMODEM, P_ZEDZAP, P_DIRZAP,
#ifdef HYDRA8K16K
      P_HYDRA4, P_HYDRA8, P_HYDRA16,
#endif
      P_HYDRA, P_JANUS, P_NCP, O_NRQ, O_FNC, O_EII, O_XMA, P_NONE },
    { O_RH1, O_PUA, O_PUP, O_NPU, O_HAT, O_HXT, O_HRQ, P_NONE }
};

static struct pcod_t {
    char *code;
    char *err;
} pcod[2];

int emsi_parsecod(char *lcod, char *ccod)
{
    char *q, *p, *c = NULL;
    register int o = 0;
    register int i, j;

    DEBUG(('E',3,"link codes: '%s', compatibility codes: '%s'", lcod, ccod));
    
    chat_need = 0;

    pcod[0].code = ccod;
    pcod[1].code = lcod;
    pcod[0].err = "proto";
    pcod[1].err = "traff";
    
    for( j = 0; j < 2; j++ ) {
        q = pcod[j].code;
        while(( p = strsep( &q, "," ))) {
            if ( ! *p )
                break;

            DEBUG(('E', 4, "emsi %s flag: '%s'", pcod[j].err, p));

            if (( c = strstr( ccodes[ j ], p ))) {
                i = ( c - ccodes[j] ) >> 2;
                o |= iccodes[j][i];
            } else if ( !j && !strcmp( p, "CHT" )) { 
                chat_need = 1;
                continue;
            } else
                DEBUG(('E', 3, "unknown emsi %s flag: '%s'", pcod[j].err, p));
        }
    }

    DEBUG(('E',5,"emsi_parsecod returns: 0x%x", o));
    return o;
}
