/**********************************************************
 * IP tools
 * $Id: ip_tools.c,v 1.4 2004/12/30 19:24:46 mitry Exp $
 **********************************************************/

#include "headers.h"
#include "ip_tools.h"

/* Returns hostname or ip address */
const char *get_hostname(struct sockaddr_in *addr, char *host, int len)
{
  struct hostent *he;
  struct sockaddr_in sa;

  memcpy( &sa, addr, sizeof( struct sockaddr_in ) );
  if ( cfgi( CFG_RESOLVEHOSTNAME ))
  {
    he = gethostbyaddr( (char *) &sa.sin_addr, sizeof sa.sin_addr, AF_INET );
    if ( he ) {
      snprintf( host, len, "%s (%s)", he->h_name, inet_ntoa( sa.sin_addr ) );
      return host;
    }
  }
  strncpy(host, inet_ntoa( sa.sin_addr ), len );
  return host;
}
