/*
 * $Id: qslib.h,v 1.5 2005/02/09 11:18:44 mitry Exp $
 *
 * $Log: qslib.h,v $
 * Revision 1.5  2005/02/09 11:18:44  mitry
 * More proper writing for XBLANK
 *
 * Revision 1.4  2005/02/08 20:02:21  mitry
 * New define for SIZES and SIZEC
 *
 *
 */

#ifndef __QSLIB_H__
#define __QSLIB_H__

extern char progname[];
extern char version[];
extern char cvsdate[];
extern char *osname;

#define FETCH32(p) (((byte*)(p))[0]+(((byte*)(p))[1]<<8)+ \
                   (((byte*)(p))[2]<<16)+(((byte*)(p))[3]<<24))
#define STORE32(p,i) ((byte*)(p))[0]=i;((byte*)(p))[1]=i>>8; \
                       ((byte*)(p))[2]=i>>16;((byte*)(p))[3]=i>>24;
#define INC32(p) p=(byte*)(p)+4
#define FETCH16(p) (((byte*)(p))[0]+(((byte*)(p))[1]<<8))
#define STORE16(p,i) ((byte*)(p))[0]=i;((byte*)(p))[1]=i>>8;
#define INC16(p) p=(byte*)(p)+2

#define BYTES   ((dword) 9999)
#define KBYTES  ((dword) 10238976)
#define MBYTES  ((dword) 10484711424)

#define SIZES(x) ( ((dword)(x)<BYTES) ? (x) : ( ((dword)(x)<KBYTES) ? (int)((dword)(x)/1024) : (int)((dword)(x)/1048576) ))
#define SIZEC(x) ( ((dword)(x)<BYTES) ? 'b' : ( ((dword)(x)<KBYTES) ? 'k'               : 'M' ))

/*
#define SIZES(x) (((x)<1024) ? (x) : (((x)<1048576) ? ((x)/1024) : (((x)<1073741824) ? ((x)/1048576) : ((x)/1073741824))))
#define SIZEC(x) (((x)<1024) ? 'b' : (((x)<1048576) ? 'K' : (((x)<1073741824) ? 'M' : 'G' )))
*/

#define xfree(p) \
    do {                                       \
        /* DEBUG(('G',4, "xfree, file: %s:%d", __FILE__, __LINE__ )); */ \
        if ( p )                               \
            free(p);                           \
        (p) = NULL;                            \
    } while(0)

#define SS(str) ((str)?(str):"")

#define XBLANK( str ) ( *(str) && isspace( *(str) ))
#define xmalloc(n) _xmalloc(n); /* DEBUG(('G',4, "xmalloc, file: %s:%d", __FILE__, __LINE__ )) */
#define xcalloc(n,s) _xcalloc(n,s); /* DEBUG(('G',4, "xcalloc, file: %s:%d", __FILE__, __LINE__ )) */
extern void *_xmalloc(size_t size);
extern void *_xcalloc(size_t number, size_t size);
extern void *xrealloc(void *ptr, size_t size);
extern char *xstrdup(char *str);

extern char *restrcpy(char **dst, char *src);
extern char *restrcat(char **dst, char *src);
extern void strlwr(char *s);
extern void strupr(char *s);
extern void strtr(char *s, char a, char b);
extern void chop(char *s, int n);
extern char *skip_blanks( char *str );
extern void skip_blanksr( char *str );

#ifndef HAVE_STRLCPY
extern char *xstrcpy(char *dst, char *src, size_t size);
#else
#define xstrcpy(dst,src,size)	(strlcpy((dst),(src),(size)),(dst))
#endif

#ifndef HAVE_STRLCAT
extern char *xstrcat(char *dst, char *src, size_t size);
#else
#define xstrcat(dst,src,size)	(strlcat((dst),(src),(size)),(dst))
#endif

extern time_t gmtoff(time_t tt,int mode);

#ifndef HAVE_SETPROCTITLE
extern void setargspace(int argc,char **argv,char **envp);
extern void setproctitle(char *str);
#endif

extern void u_vers(char *progn);

#endif
